// 3D Graphics Experiments with MMX and SSE/SSE2
// Using Visual Studio 2005 by Jeff Cummings
// Following Tricks of the 3D Game Programming Gurus
// written by Andre LaMothe of http://www.xgamestation.com

#include <iostream>
#include <iomanip>
using namespace std;

int main()
{
// Converting 2D Cartesian Coordinates to Polar Coordinates
	int x=9, y=8;
	float r, rho, theta = 180.0;

	cout << "This portion of the program will convert x,y to r,theta: " << endl << "Please enter X Coord: ";
//	cin >> x;
	cout << endl << "Please enter Y: ";
//	cin >> y;
	cout << endl << "You entered: (x,y) : (" << x << "," << y << ")" << endl << "this converts to: ";

	_asm
	{
		fild x
		fimul x
		fild y
		fimul y
		faddp st(1), st(0)
		fsqrt
		fst r
		emms
		fild y			// st0 = y
		fild x			// st0 = x, st1 = y
		fpatan			// st0 = radians
		fmul theta		// st0 = radians * 180
		fldpi			// st0 = pi, st1 = radians * 180
		fdivp st(1), st(0)	// st0 = radians * 180 / pi
		fst theta		// theta = answer
		emms
	}
	
	cout << "(r,theta) : (" << r << "," << theta << ")" << endl;

// Converting 3D Cartesian Coords to 3D Spherical Coords
// 3D Polar = (rho,phi,theta) pronounced (row,fee,theta)
	int z=30;
	float phi = 180.0;

	cout << endl << "Now enter a Z Coord: ";
//	cin >> z;

	_asm {
		emms
		fild x		// st0 = x
		fimul x		// st0 = x^2
		fild y		// st0 = y, st1 = x^2
		fimul y		// st0 = y^2, st1 = x^2
		fild z		// st0 = z, st1 = y^2, st2 = x^2
		fimul z		// st0 = z^2, st1 = y^2, st2 = x^2
		faddp st(1), st(0)	// st0 = z^2 + y^2, st1 = x^2
		faddp st(1), st(0)	// st0 = z^2 + y^2 + x^2
		fsqrt
		fstp rho	// rho = sqrt(x^2 + y^2 + z^2)
		emms
		fld r		// st0 = r
		fdiv rho	// st0 = r/rho
		fld st(0)	// st0 = st1 = r/rho
		fmul st(0), st(0)	// st0 = (r/rho)^2, st1 = r/rho
		fld1		// st0 = 1.0 / st1 = (r/rho)^2, st2 = r/rho
		fsubrp st(1), st(0)	// st0 = 1 - (r/rho)^2, st1 = r/rho
		fsqrt		// st0 = sqrt[1 - (r/rho)^2], st1 = r/rho
		fpatan		// st0 = arctan of [(r/rho) / ( sqrt [ 1- (r/rho)^2 ] ) ]
		fmul phi		// st0 = radians * 180
		fldpi			// st0 = pi, st1 = radians * 180
		fdivp st(1), st(0)	// st0 = radians * 180 / pi
		fstp phi
		emms
	}

	cout << "Rho = " << rho << " Phi = " << phi << " Theta = " << theta << endl;

// Calculating the length of a 3D Vector.
	int vector[4] = { 9,5,7,4 };
	int v3dlength = 10;

	_asm {
		emms
		fild vector[0]
		fimul vector[0]
		fistp vector[0]
		fild vector[4]
		fimul vector[4]
		fistp vector[4]
		fild vector[8]
		fimul vector[8]
		fistp vector[8]
		emms
	}

	cout << endl << "Length of 3D Vector: (" << vector[0] << "," << vector[1] << "," << vector[2] << ") is = " << v3dlength << endl;

	cout << endl << "Did you see the way that I had to access the array inside the _asm portion of my code???" << endl;
	cin >> v3dlength;

	return 0;		// return to dos?
}
